VTK: vtkShadowMapBakerPass Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkShadowMapBakerPass Class Reference

Implement a builder of shadow map pass. More...

`#include <vtkShadowMapBakerPass.h>`

Inheritance diagram for vtkShadowMapBakerPass:
[legend]
Collaboration diagram for vtkShadowMapBakerPass:
[legend]

## Public Types
typedef vtkOpenGLRenderPass | Superclass
Public Types inherited from vtkOpenGLRenderPass
typedef vtkRenderPass | Superclass
Public Types inherited from vtkRenderPass
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkShadowMapBakerPass * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Render (const vtkRenderState *s) override
| Perform rendering according to a render state `s`. More...
void | ReleaseGraphicsResources (vtkWindow *w) override
| Release graphics resources and ask components to release their own resources. More...
bool | GetHasShadows ()
| INTERNAL USE ONLY. More...
bool | LightCreatesShadow (vtkLight *l)
| INTERNAL USE ONLY. More...
std::vector< vtkSmartPointer< vtkTextureObject > > * | GetShadowMaps ()
| INTERNAL USE ONLY Internally used by vtkShadowMapBakerPass and vtkShadowMapPass. More...
std::vector< vtkSmartPointer< vtkCamera > > * | GetLightCameras ()
| INTERNAL USE ONLY. More...
bool | GetNeedUpdate ()
| INTERNAL USE ONLY. More...
void | SetUpToDate ()
virtual vtkRenderPass * | GetOpaqueSequence ()
| Delegate for rendering the camera, lights, and opaque geometry. More...
virtual void | SetOpaqueSequence (vtkRenderPass *opaqueSequence)
| Delegate for rendering the camera, lights, and opaque geometry. More...
virtual vtkRenderPass * | GetCompositeZPass ()
| Delegate for compositing of the shadow maps across processors. More...
virtual void | SetCompositeZPass (vtkRenderPass *compositeZPass)
| Delegate for compositing of the shadow maps across processors. More...
virtual void | SetResolution (unsigned int)
| Set/Get the number of pixels in each dimension of the shadow maps (shadow maps are square). More...
virtual unsigned int | GetResolution ()
| Set/Get the number of pixels in each dimension of the shadow maps (shadow maps are square). More...
Public Member Functions inherited from vtkOpenGLRenderPass
vtkOpenGLRenderPass * | NewInstance () const
virtual vtkMTimeType | GetShaderStageMTime ()
| For multi-stage render passes that need to change shader code during a single pass, use this method to notify a mapper that the shader needs to be rebuilt (rather than reuse the last cached shader. More...
virtual void | SetActiveDrawBuffers (unsigned int)
| Number of active draw buffers. More...
virtual unsigned int | GetActiveDrawBuffers ()
virtual bool | PostReplaceShaderValues (std::string &vertexShader, std::string &geometryShader, std::string &fragmentShader, vtkAbstractMapper *mapper, vtkProp *prop)
| Use vtkShaderProgram::Substitute to replace. More...
Public Member Functions inherited from vtkRenderPass
vtkRenderPass * | NewInstance () const
virtual int | GetNumberOfRenderedProps ()
| Number of props rendered at the last Render call. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkShadowMapBakerPass * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkShadowMapBakerPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkOpenGLRenderPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkOpenGLRenderPass * | SafeDownCast (vtkObjectBase *o)
static vtkInformationObjectBaseVectorKey * | RenderPasses ()
| Key containing information about the current pass. More...
Static Public Member Functions inherited from vtkRenderPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkRenderPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkShadowMapBakerPass ()
| Default constructor. More...
| ~vtkShadowMapBakerPass () override
| Destructor. More...
bool | PreReplaceShaderValues (std::string &vertexShader, std::string &geometryShader, std::string &fragmentShader, vtkAbstractMapper *mapper, vtkProp *prop) override
| Use vtkShaderProgram::Substitute to replace. More...
bool | SetShaderParameters (vtkShaderProgram *program, vtkAbstractMapper *mapper, vtkProp *prop, vtkOpenGLVertexArrayObject *VAO=nullptr) override
| Update the uniforms of the shader program. More...
void | PointNearFar (double *v, double *pt, double *dir, double &mNear, double &mFar, bool initialized)
| Helper method to compute the mNearest point in a given direction. More...
void | BoxNearFar (double *bb, double *pt, double *dir, double &mNear, double &mFar)
| Compute the min/max of the projection of a box in a given direction. More...
void | BuildCameraLight (vtkLight *light, double *boundingBox, vtkCamera *lcamera)
| Build a camera from spot light parameters. More...
void | CheckSupport (vtkOpenGLRenderWindow *w)
| Check if shadow mapping is supported by the current OpenGL context. More...
Protected Member Functions inherited from vtkOpenGLRenderPass
| vtkOpenGLRenderPass ()
| ~vtkOpenGLRenderPass () override
void | PreRender (const vtkRenderState *s)
| Call before rendering to update the actors' information keys. More...
void | PostRender (const vtkRenderState *s)
| Call after rendering to clean up the actors' information keys. More...
Protected Member Functions inherited from vtkRenderPass
| vtkRenderPass ()
| Default constructor. More...
| ~vtkRenderPass () override
| Destructor. More...
void | UpdateCamera (vtkRenderer *renderer)
| Call UpdateCamera() on Renderer. More...
void | ClearLights (vtkRenderer *renderer)
| Call ClearLights() on Renderer. More...
void | UpdateLightGeometry (vtkRenderer *renderer)
| Call UpdateLightGeometry() on Renderer. More...
void | UpdateLights (vtkRenderer *renderer)
| Call UpdateLights() on Renderer. More...
void | UpdateGeometry (vtkRenderer *renderer, vtkFrameBufferObjectBase *fbo=nullptr)
| Call UpdateGeometry() on Renderer. More...
void | SetLastRenderingUsedDepthPeeling (vtkRenderer *renderer, bool value)
| Modify protected member LastRenderingUsedDepthPeeling on Renderer. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkRenderPass * | OpaqueSequence
vtkRenderPass * | CompositeZPass
unsigned int | Resolution
bool | HasShadows
vtkOpenGLFramebufferObject * | FrameBufferObject
| Graphics resources. More...
std::vector< vtkSmartPointer< vtkTextureObject > > * | ShadowMaps
std::vector< vtkSmartPointer< vtkCamera > > * | LightCameras
vtkTimeStamp | LastRenderTime
bool | NeedUpdate
size_t | CurrentLightIndex
Protected Attributes inherited from vtkOpenGLRenderPass
unsigned int | ActiveDrawBuffers = 0
Protected Attributes inherited from vtkRenderPass
int | NumberOfRenderedProps
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Implement a builder of shadow map pass.

Bake a list of shadow maps, once per spot light. It work in conjunction with the vtkShadowMapPass, which uses the shadow maps for rendering the opaque geometry (a technique to render hard shadows in hardware).

This pass expects an initialized depth buffer and color buffer. Initialized buffers means they have been cleared with farest z-value and background color/gradient/transparent color. An opaque pass may have been performed right after the initialization.

Its delegate is usually set to a vtkOpaquePass.

Implementation:
  The first pass of the algorithm is to generate a shadow map per light (depth map from the light point of view) by rendering the opaque objects

See also
  vtkRenderPass, vtkOpaquePass, vtkShadowMapPass

Online Examples:

Tests:
  vtkShadowMapBakerPass (Tests)

Definition at line 57 of file vtkShadowMapBakerPass.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkOpenGLRenderPass vtkShadowMapBakerPass::Superclass

Definition at line 61 of file vtkShadowMapBakerPass.h.

## Constructor & Destructor Documentation

## ◆ vtkShadowMapBakerPass()

vtkShadowMapBakerPass::vtkShadowMapBakerPass | ( |  | ) |
| protected

Default constructor.

DelegatetPass is set to NULL.

## ◆ ~vtkShadowMapBakerPass()

vtkShadowMapBakerPass::~vtkShadowMapBakerPass | ( |  | ) |
| overrideprotected

Destructor.

## Member Function Documentation

## ◆ New()

static vtkShadowMapBakerPass* vtkShadowMapBakerPass::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkShadowMapBakerPass::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkShadowMapBakerPass::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkOpenGLRenderPass.

## ◆ SafeDownCast()

static vtkShadowMapBakerPass* vtkShadowMapBakerPass::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkShadowMapBakerPass::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkOpenGLRenderPass.

## ◆ NewInstance()

vtkShadowMapBakerPass* vtkShadowMapBakerPass::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkShadowMapBakerPass::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkOpenGLRenderPass.

## ◆ Render()

void vtkShadowMapBakerPass::Render | ( | const vtkRenderState * | s | ) |
| overridevirtual

Perform rendering according to a render state `s`.

Precondition
  s_exists: s!=0

Implements vtkRenderPass.

## ◆ ReleaseGraphicsResources()

void vtkShadowMapBakerPass::ReleaseGraphicsResources | ( | vtkWindow * | w | ) |
| overridevirtual

Release graphics resources and ask components to release their own resources.

Precondition
  w_exists: w!=0

Reimplemented from vtkRenderPass.

## ◆ GetOpaqueSequence()

virtual vtkRenderPass* vtkShadowMapBakerPass::GetOpaqueSequence | ( |  | ) |
| virtual

Delegate for rendering the camera, lights, and opaque geometry.

If it is NULL, nothing will be rendered and a warning will be emitted. It defaults to a vtkCameraPass with a sequence of vtkLightPass/vtkOpaquePass.

## ◆ SetOpaqueSequence()

virtual void vtkShadowMapBakerPass::SetOpaqueSequence | ( | vtkRenderPass * | opaqueSequence | ) |
| virtual

Delegate for rendering the camera, lights, and opaque geometry.

If it is NULL, nothing will be rendered and a warning will be emitted. It defaults to a vtkCameraPass with a sequence of vtkLightPass/vtkOpaquePass.

## ◆ GetCompositeZPass()

virtual vtkRenderPass* vtkShadowMapBakerPass::GetCompositeZPass | ( |  | ) |
| virtual

Delegate for compositing of the shadow maps across processors.

If it is NULL, there is no z compositing. It is usually set to a vtkCompositeZPass (Parallel package). Initial value is a NULL pointer.

## ◆ SetCompositeZPass()

virtual void vtkShadowMapBakerPass::SetCompositeZPass | ( | vtkRenderPass * | compositeZPass | ) |
| virtual

Delegate for compositing of the shadow maps across processors.

If it is NULL, there is no z compositing. It is usually set to a vtkCompositeZPass (Parallel package). Initial value is a NULL pointer.

## ◆ SetResolution()

virtual void vtkShadowMapBakerPass::SetResolution | ( | unsigned int |  | ) |
| virtual

Set/Get the number of pixels in each dimension of the shadow maps (shadow maps are square).

Initial value is 256. The greater the better. Resolution does not have to be a power-of-two value.

## ◆ GetResolution()

virtual unsigned int vtkShadowMapBakerPass::GetResolution | ( |  | ) |
| virtual

Set/Get the number of pixels in each dimension of the shadow maps (shadow maps are square).

Initial value is 256. The greater the better. Resolution does not have to be a power-of-two value.

## ◆ GetHasShadows()

bool vtkShadowMapBakerPass::GetHasShadows | ( |  | ) |

INTERNAL USE ONLY.

Internally used by vtkShadowMapBakerPass and vtkShadowMapPass.

Tell if there is at least one shadow. Initial value is false.

## ◆ LightCreatesShadow()

bool vtkShadowMapBakerPass::LightCreatesShadow | ( | vtkLight * | l | ) |

INTERNAL USE ONLY.

Internally used by vtkShadowMapBakerPass and vtkShadowMapPass.

Tell if the light ‘l’ can create shadows. The light has to not be a head light and to be directional or positional with an angle less than 180 degrees.

Precondition
  l_exists: l!=0

## ◆ GetShadowMaps()

std::vector<vtkSmartPointer<vtkTextureObject> >* vtkShadowMapBakerPass::GetShadowMaps | ( |  | ) |

INTERNAL USE ONLY Internally used by vtkShadowMapBakerPass and vtkShadowMapPass.

Give access to the baked shadow maps.

## ◆ GetLightCameras()

std::vector<vtkSmartPointer<vtkCamera> >* vtkShadowMapBakerPass::GetLightCameras | ( |  | ) |

INTERNAL USE ONLY.

Internally used by vtkShadowMapBakerPass and vtkShadowMapPass.

Give access the cameras builds from the lights.

## ◆ GetNeedUpdate()

bool vtkShadowMapBakerPass::GetNeedUpdate | ( |  | ) |

INTERNAL USE ONLY.

Internally used by vtkShadowMapBakerPass and vtkShadowMapPass.

Do the shadows need to be updated? Value changed by vtkShadowMapBakerPass and used by vtkShadowMapPass. Initial value is true.

## ◆ SetUpToDate()

void vtkShadowMapBakerPass::SetUpToDate | ( |  | ) |

## ◆ PreReplaceShaderValues()

bool vtkShadowMapBakerPass::PreReplaceShaderValues | ( | std::string & | vertexShader,
|  | std::string & | geometryShader,
|  | std::string & | fragmentShader,
|  | vtkAbstractMapper * | mapper,
|  | vtkProp * | prop
| ) |  |
| overrideprotectedvirtual

Use vtkShaderProgram::Substitute to replace.

//VTK::XXX:YYY

declarations in the shader sources. Gets called before other mapper shader replacements Return false on error.

Reimplemented from vtkOpenGLRenderPass.

## ◆ SetShaderParameters()

bool vtkShadowMapBakerPass::SetShaderParameters | ( | vtkShaderProgram * | program,
|  | vtkAbstractMapper * | mapper,
|  | vtkProp * | prop,
|  | vtkOpenGLVertexArrayObject * | VAO = `nullptr`
| ) |  |
| overrideprotectedvirtual

Update the uniforms of the shader program.

Return false on error.

Reimplemented from vtkOpenGLRenderPass.

## ◆ PointNearFar()

void vtkShadowMapBakerPass::PointNearFar | ( | double * | v,
|  | double * | pt,
|  | double * | dir,
|  | double & | mNear,
|  | double & | mFar,
|  | bool | initialized
| ) |  |
| protected

Helper method to compute the mNearest point in a given direction.

To be called several times, with initialized = false the first time. v: point pt: origin of the direction dir: direction

## ◆ BoxNearFar()

void vtkShadowMapBakerPass::BoxNearFar | ( | double * | bb,
|  | double * | pt,
|  | double * | dir,
|  | double & | mNear,
|  | double & | mFar
| ) |  |
| protected

Compute the min/max of the projection of a box in a given direction.

bb: bounding box pt: origin of the direction dir: direction

## ◆ BuildCameraLight()

void vtkShadowMapBakerPass::BuildCameraLight | ( | vtkLight * | light,
|  | double * | boundingBox,
|  | vtkCamera * | lcamera
| ) |  |
| protected

Build a camera from spot light parameters.

Precondition
  light_exists: light!=0
  lcamera_exists: lcamera!=0

## ◆ CheckSupport()

void vtkShadowMapBakerPass::CheckSupport | ( | vtkOpenGLRenderWindow * | w | ) |
| protected

Check if shadow mapping is supported by the current OpenGL context.

Precondition
  w_exists: w!=0

## Member Data Documentation

## ◆ OpaqueSequence

vtkRenderPass* vtkShadowMapBakerPass::OpaqueSequence
| protected

Definition at line 210 of file vtkShadowMapBakerPass.h.

## ◆ CompositeZPass

vtkRenderPass* vtkShadowMapBakerPass::CompositeZPass
| protected

Definition at line 212 of file vtkShadowMapBakerPass.h.

## ◆ Resolution

unsigned int vtkShadowMapBakerPass::Resolution
| protected

Definition at line 214 of file vtkShadowMapBakerPass.h.

## ◆ HasShadows

bool vtkShadowMapBakerPass::HasShadows
| protected

Definition at line 216 of file vtkShadowMapBakerPass.h.

## ◆ FrameBufferObject

vtkOpenGLFramebufferObject* vtkShadowMapBakerPass::FrameBufferObject
| protected

Graphics resources.

Definition at line 221 of file vtkShadowMapBakerPass.h.

## ◆ ShadowMaps

std::vector<vtkSmartPointer<vtkTextureObject> >* vtkShadowMapBakerPass::ShadowMaps
| protected

Definition at line 223 of file vtkShadowMapBakerPass.h.

## ◆ LightCameras

std::vector<vtkSmartPointer<vtkCamera> >* vtkShadowMapBakerPass::LightCameras
| protected

Definition at line 224 of file vtkShadowMapBakerPass.h.

## ◆ LastRenderTime

vtkTimeStamp vtkShadowMapBakerPass::LastRenderTime
| protected

Definition at line 226 of file vtkShadowMapBakerPass.h.

## ◆ NeedUpdate

bool vtkShadowMapBakerPass::NeedUpdate
| protected

Definition at line 227 of file vtkShadowMapBakerPass.h.

## ◆ CurrentLightIndex

size_t vtkShadowMapBakerPass::CurrentLightIndex
| protected

Definition at line 228 of file vtkShadowMapBakerPass.h.

The documentation for this class was generated from the following file:

- Rendering/OpenGL2/vtkShadowMapBakerPass.h